function sac_apply_params

global ClusterInfo;
global FileInfo

store=ClusterInfo;%save ClusterInfo in temporary variable
store2=FileInfo;% save FileInfo in a temporary variable
%read parameter file
[param_filename,param_pathname]=uigetfile('*ruleset.mat', 'Choose Ruleset file');
if param_filename==0
    return;
end
load ([param_pathname param_filename]);

h=waitbar(0,'Writing Channels...','Position',[250 400 270 60]);

for Channel=1:length(ruleset)% Loop across channels
    waitbar(Channel/length(ruleset),h);
    if length(ruleset)<Channel, % in case last channels weren't classified
        break
    end
    if isempty(ruleset(Channel).nu),% if not all channel's  parameters were saved
        continue
    end
    if length(ruleset(Channel).Units)>0 % assuming you want to reclassify noise only channels
        ClusterInfo=ruleset(Channel);
        ClusterInfo.ChannelNumber=Channel;
        FileInfo(1).ThresholdLocation=FileInfo(1).T(Channel).T;
        sac_write_n;
    end
end

ClusterInfo=store;
FileInfo=store2;
close(h);