function sac_filescan(j)
% scans files (now its  *.nev  *.plx *.nex *.map *.nsn)

global FileInfo
global Handles
% tic
% Loading DLL file
switch FileInfo(1).format
    case '.nev'
        [pathstr,dllname,ext,versn] = fileparts('nsNEVLibrary.dll');
        [nsresult] = ns_SetLibrary(dllname);
    case '.plx'
        [pathstr,dllname,ext,versn] = fileparts('nsPlxLibrary.dll');
        [nsresult] = ns_SetLibrary(dllname);
    case '.nex'
        [pathstr,dllname,ext,versn] = fileparts('NeuroExplorerNeuroShareLibrary.dll');
        [nsresult] = ns_SetLibrary(dllname);
    case '.map'
        [pathstr,dllname,ext,versn] = fileparts('nsAOLibrary.dll');  % Alpha & Omega files
        [nsresult] = ns_SetLibrary(dllname);
    case '.nsn'
        [pathstr,dllname,ext,versn] = fileparts('nsNSNLibrary.dll');  % neuroshare native format
        [nsresult] = ns_SetLibrary(dllname);
        %     case '.stb'
        %         [pathstr,dllname,ext,versn] = fileparts('nsTDTLib.dll');  % TDT files
        %         [nsresult] = ns_SetLibrary(dllname)  % currently doesen't work
    otherwise
        [dllfname,pathname]=uigetfile({'*.dll'},'Choose an appropriate DLL Library');
        dllname=strtok(dllfname,'.')                                     % manually load a dll file
        [nsresult] = ns_SetLibrary(dllname);
end
if j==1,
    FileInfo(1).dllname=dllname;
end
clear pathstr versn;

% Opening the file
[nsresult, hfile] = ns_OpenFile( FileInfo(j).filename);
FileInfo(j).hfile=hfile;
if nsresult~=0,
    error('Loading Went Wrong')
end

% Data aquisition:
%-------------------------------
[nsresult, nsFileInfo] = ns_GetFileInfo(FileInfo(j).hfile);
EntityNum=nsFileInfo.EntityCount;                          % returns number of entities
% FileInfo(j).TimeStampResolution=nsFileInfo.TimeStampResolution; %min timestamp resolution
% TimeSpan=nsFileInfo.TimeSpan
% [ns_RESULT, nsEntityInfo] = ns_GetEntityInfo(hFile, EntityID) ;

[ns_RESULT, nsEntityInfo] = ns_GetEntityInfo(FileInfo(j).hfile,[1:1:EntityNum]) ;
ChannelList=find([nsEntityInfo.EntityType]==3); % channels by their entity numbers

FileInfo(j).ChannelEntityID=ChannelList;% contains entity ID's of channels channel entity type is 3
FileInfo(j).ActiveChannels=[1:1:length(ChannelList)];
C=[nsEntityInfo.ItemCount]; % Item Count in all entities
FileInfo(j).SpikesNumber=C(ChannelList); % picks out only item count on channel entities
%% 21.01.09 delete empty channels
deleteCh=find(~FileInfo(j).SpikesNumber);
FileInfo(j).SpikesNumber(deleteCh)=[];
FileInfo(j).ActiveChannels(deleteCh)=[];
%%
if isfield(Handles,'nVperBit')
    FileInfo(1).nVperBit(FileInfo(j).ActiveChannels)=Handles.nVperBit;
else
    FileInfo(1).nVperBit(FileInfo(j).ActiveChannels)=1000;% the points are in uV units, so says their example, that's probably wrong
end

% [ns_RESULT, nsSegmentInfo] = ns_GetSegmentInfo(hFile, EntityID);
[ns_RESULT, nsSegmentInfo] = ns_GetSegmentInfo(FileInfo(j).hfile, FileInfo(j).ChannelEntityID(1));
FileInfo(1).SamplingRate=nsSegmentInfo.SampleRate*1e-3; % sample rate in KHz I guess...
% finding min length of waveform in all files
MinSampleCount=nsSegmentInfo.MinSampleCount;
FileInfo(1).MinSampleCount=min(FileInfo(1).MinSampleCount,MinSampleCount);
% [ns_result,TimeStamp,Data,DataSize]=ns_GetEventData(hfile,1,7)
%%%%%%%%%%%%%%%%%%%%%%
% Closing the file:
% ns_RESULT = ns_CloseFile(hfile);
% filescantoc=toc
