function sac_waveforms(ChannelNumber,TotalNumber,GetNumber)
% this function loads waveforms by either using neuroshare 'Neuro' or by a
% custom loading engine, 'Engine'.

% there used to be saturation considerations... don't have these here

global FileInfo;
global WaveformInfo;
% tic
GetPackets=GetNumber(1);
GetPacketSize=GetNumber(2);
[GetSize,Method]=min([TotalNumber,prod(GetNumber)]);% the number of spikes to be loaded
g=TotalNumber/GetPackets;
indexes=find(rem([1:TotalNumber],g)<GetPacketSize);% indexes of spikes to be read

%% initialization:
MinSampleCount=FileInfo(1).MinSampleCount;
WaveformInfo=[];
WaveformInfo.Waveforms=zeros(GetSize, FileInfo(1).MinSampleCount);
WaveformInfo.Times=zeros(GetSize,1);                                 % column vectors
WaveformInfo.Unit=zeros(GetSize,1);
oldnumRead=0;
h=waitbar(0,'Loading Waveforms...');
switch(FileInfo(1).load)
    case 'Neuro'
        %         [nsresult] = ns_SetLibrary(FileInfo(1).dllname) ;              % opening dll
        for j=1:length(FileInfo)
            EntityID=FileInfo(j).ChannelEntityID(ChannelNumber);
            %             [nsresult, hfile] = ns_OpenFile( FileInfo(j).filename);% opening the file
            SpikesOnChannel=FileInfo(j).SpikesNumber(ChannelNumber); % inserted this line 05.05.06
            c=find(indexes<=SpikesOnChannel);                  % c is vector of indexes that will be read from file j
            % length(c) is number of spikes added by each file
            indexes=indexes(length(c)+1:end)-SpikesOnChannel;  % preparing index vector for next file
            i=oldnumRead+[1:length(c)];% states the current lines in big matrix
            index=i-oldnumRead;
            % [ns_RESULT, nsSegmentInfo] = ns_GetSegmentInfo(hfile, EntityID);
            [ns_RESULT, TimeStamp, Data, SampleCount, UnitID] = ns_GetSegmentData(FileInfo(j).hfile, EntityID,c);
            WaveformInfo.Times(i,1)=(1000*TimeStamp);% time in ms
            WaveformInfo.Unit(i,1)=uint8(UnitID);
            WaveformInfo.Waveforms(i,:)=Data(1:FileInfo(1).MinSampleCount,:)';
            oldnumRead=oldnumRead+length(c)+1;
            %             ns_RESULT = ns_CloseFile(hfile);
            waitbar(oldnumRead/GetSize);
        end
        close(h);
    case 'Engine'
        for j=1:length(FileInfo)
            SpikesOnChannel=FileInfo(j).SpikesNumber(ChannelNumber); % inserted this line 05.05.06
            c=find(indexes<=SpikesOnChannel);                  % c is vector of indexes that will be read from file j
            % length(c) is number of spikes added by each file
            indexes=indexes(length(c)+1:end)-SpikesOnChannel;  % preparing index vector for next file
            i=oldnumRead+[1:length(c)];% states the current lines in big matrix
            index=i-oldnumRead;
            TimeStamp=sac_engine(FileInfo(1).Fhandle,[j,double(ChannelNumber),c],'times');
            Data=sac_engine(FileInfo(1).Fhandle,[j,double(ChannelNumber),c],'waveforms'); % evry row is a spike
            UnitID=sac_engine(FileInfo(1).Fhandle,[j,double(ChannelNumber),c],'UnitID');
            WaveformInfo.Times(i,1)=1000*TimeStamp(index);% time in ms
            WaveformInfo.Unit(i,1)=UnitID(index);
            WaveformInfo.Waveforms(i,:)=Data(index,1:FileInfo(1).MinSampleCount);
            oldnumRead=oldnumRead+length(c)+1;
            waitbar(oldnumRead/GetSize);
        end
        close(h);
end

[value,index]=max(abs(WaveformInfo.Waveforms),[],2);
index=mean(index);
FileInfo(1).ThresholdLocation=max(3,ceil(index)-5);
FileInfo(1).T(ChannelNumber).T=max(3,ceil(index)-5);
% FileInfo(1).LowThresh(ChannelNumber)=mean(W(ceil(index)-5);
% waveformstoc=toc




