function sac_write_nev(Waveforms,Times,Freq,nV_per_bit,Units,ChannelNumber,j,isnew)
% sac_write_nev  is a modified version of the function wirte_nev, which
% allows writing sorted data to a *.nev file.
%  If you wish to create a *.nev outside SAC, you should use the function write_nev

global FileInfo
[count,waveform_length]=size(Waveforms);

switch (isnew)
    case 'yes'
        Cnum=length(FileInfo(j).ActiveChannels);
        fid=fopen([FileInfo(j).write.pathname FileInfo(j).write.filename],'w');
        Cnum=length(FileInfo(j).ActiveChannels);
        fwrite(fid,'NEURALEV','char');%FileType,8
        fwrite(fid,[2 0],'uchar');%Version,2
        fwrite(fid,[0 0],'char');%format additional,2
        fwrite(fid,336+32*Cnum,'uint32');% Header Size,uint32. 336+32*#of extended headers
        fwrite(fid,waveform_length*2+8,'uint32');% Packet Size, uint32
        fwrite(fid,Freq,'uint32');%sampling frequency of time stamps, uint32
        fwrite(fid,Freq,'uint32');%sampling frequency of samples
        fwrite(fid,zeros(1,8),'uint16');%Time origin,8xuint16
        fwrite(fid,zeros(1,32),'char');%application,32
        fwrite(fid,zeros(1,256),'char');%comment,256
        fwrite(fid,Cnum,'uint32');%extended header number, uint32

        Cnum=length(FileInfo(j).ActiveChannels); % number of channels in file
        for i=1:Cnum,
            %Write extended header, for every channel
            fwrite(fid,'NEUEVWAV','char'); %Packet type identifier, 8
            fwrite(fid,i,'uint16'); % Electrode ID
            fwrite(fid,1,'uchar'); % Physical connector
            fwrite(fid,1,'uchar'); % Physical connector pin
            fwrite(fid,nV_per_bit,'uint16'); % Gain, nV per bit
            fwrite(fid,0,'uint16'); % EnergyThresh
            fwrite(fid,0,'int16'); % HighThresh
            fwrite(fid,0,'int16'); % LowThresh
            fwrite(fid,0,'uchar'); % SortedUnits
            fwrite(fid,2,'uchar'); % BytesPerSample
            fwrite(fid,zeros(10,1),'uchar');% ?
        end
    case 'no'
        fid=fopen([FileInfo(j).write.pathname FileInfo(j).write.filename],'r+');
        fseek(fid,0,'eof'); % skips to end of file, to write packets there
end
%Write data packets
% h=waitbar(0,['Writing Channel ',num2str(ChannelNumber),' to File...']);

for i1=1:count  % loop across waveforms
%     if mod(i1,100)==0
%         waitbar(i1/count)
%     end
    fwrite(fid,Times(i1),'uint32');%Timestamp
    fwrite(fid,ChannelNumber,'uint16');%Channel #
    fwrite(fid,Units(i1),'uchar');%Unit #  
    fwrite(fid,0,'uchar');%Temporary place holder
    fwrite(fid,Waveforms(i1,:),'int16');%Waveform
end
% close(h);
fclose(fid);

